org.eclipse.viatra.query.runtime.localsearch.operations.util

## Class CallInformation

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.operations.util.CallInformation

-     public final class CallInformation
      extends java.lang.Object

  This class stores a precompiled version of call-related metadata and masks for local search operations
  Since:
    1.7

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static CallInformation` | `create(BinaryReflexiveTransitiveClosure constraint, java.util.Map<PVariable,java.lang.Integer> variableMapping, java.util.Set<java.lang.Integer> bindings)`
    `static CallInformation` | `create(BinaryTransitiveClosure constraint, java.util.Map<PVariable,java.lang.Integer> variableMapping, java.util.Set<java.lang.Integer> bindings)`
    `static CallInformation` | `create(PatternCallBasedDeferred constraint, java.util.Map<PVariable,java.lang.Integer> variableMapping, java.util.Set<java.lang.Integer> bindings)`
    `static CallInformation` | `create(PositivePatternCall pCall, java.util.Map<PVariable,java.lang.Integer> variableMapping, java.util.Set<java.lang.Integer> bindings)`
    `IQueryReference` | `getCall()`
    `CallWithAdornment` | `getCallWithAdornment()`
    `int[]` | `getFreeParameterIndices()` Returns the parameter indices that are unbound before the call
    `TupleMask` | `getFullFrameMask()` Returns a mask describing how all variables of a Matching Frame are mapped to parameter indexes
    `TupleMask` | `getParameterMask()` Returns a mask describing the adornment the called pattern uses
    `MatcherReference` | `getReference()`
    `TupleMask` | `getThinFrameMask()` Returns a mask describing how the bound variables of a Matching Frame are mapped to parameter indexes
    `java.util.List<java.lang.Integer>` | `getVariablePositions()`
    `java.lang.String` | `toString()`
    `java.lang.String` | `toString(java.util.function.Function<java.lang.Integer,java.lang.String> variableMapping)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static CallInformation create(PatternCallBasedDeferred constraint,
                                               java.util.Map<PVariable,java.lang.Integer> variableMapping,
                                               java.util.Set<java.lang.Integer> bindings)

    - #### create

          public static CallInformation create(PositivePatternCall pCall,
                                               java.util.Map<PVariable,java.lang.Integer> variableMapping,
                                               java.util.Set<java.lang.Integer> bindings)

    - #### create

          public static CallInformation create(BinaryTransitiveClosure constraint,
                                               java.util.Map<PVariable,java.lang.Integer> variableMapping,
                                               java.util.Set<java.lang.Integer> bindings)

    - #### create

          public static CallInformation create(BinaryReflexiveTransitiveClosure constraint,
                                               java.util.Map<PVariable,java.lang.Integer> variableMapping,
                                               java.util.Set<java.lang.Integer> bindings)

      Since:
        2.0

    - #### getThinFrameMask

          public TupleMask getThinFrameMask()

      Returns a mask describing how the bound variables of a Matching Frame are mapped to parameter indexes

    - #### getFullFrameMask

          public TupleMask getFullFrameMask()

      Returns a mask describing how all variables of a Matching Frame are mapped to parameter indexes

    - #### getParameterMask

          public TupleMask getParameterMask()

      Returns a mask describing the adornment the called pattern uses

    - #### getReference

          public MatcherReference getReference()

    - #### getCall

          public IQueryReference getCall()

      Since:
        2.1

    - #### getCallWithAdornment

          public CallWithAdornment getCallWithAdornment()

      Since:
        2.1

    - #### getFreeParameterIndices

          public int[] getFreeParameterIndices()

      Returns the parameter indices that are unbound before the call

    - #### getVariablePositions

          public java.util.List<java.lang.Integer> getVariablePositions()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString(java.util.function.Function<java.lang.Integer,java.lang.String> variableMapping)

      Since:
        2.0